/*
 * random.c - functions to get random values
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <unistd.h>

#include "defines.h"

/* global and extern variables */
extern u32 gr;
extern int random_fd;
extern u32 *rand_buf,*rand_current;
extern char random_file[MAX_CHARS_RANDOM_FILE];

/* return random integer between 0 - max-1 */
u32 rand_get(u32 max) 
{
 if(rand_current>=rand_buf+(RAND_BUF_SIZE/sizeof(u32)))
 {
  printfd("debug: reading new random bytes\n");
  if(read(random_fd,rand_buf,RAND_BUF_SIZE)!=RAND_BUF_SIZE)
  {
   if(!strcmp(random_file,""))
   {
    puts("random file end, starting over ...");
    lseek(random_fd,0,SEEK_SET);
   } else
   {
    puts("failed reading 1 mega bytes of random data");
    return -23;
   }
  }
  printfd("debug: finished reading random bytes\n");
  rand_current=rand_buf;
 }
 /* cells numbered 0...max-1 */
 return((u32)(*(rand_current++)*(max*1.0/URAND_MAX)));
}

/* get z value (linear growth of probability with depths) */
u32 rand_get_lgp(int slope,int start,u32 z_max)
{
 int z;
 u32 i,weighted_sum_z;
 weighted_sum_z=z_max*start+slope*gr;
 z=rand_get(weighted_sum_z)+1; /* +1 as rand_get returns values 0...max-1 */
 for(i=1;;i++)
 {
  z-=(start+i*slope);
  if(z<=0) break;
 }
 return(i-1); /* return values 0...z_cell-1 */
}

